* MULU3264
*
* pjwitte 2o22+
* All code is my own work except as and where stated
*
* V0.02, 64bit result
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xref mulu3264

        include dev8_keys_qlv
        include dev8_keys_sbasic
        include dev8_keys_err


*
Start
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* This version supports a 64 bit result (sort of) for demo purposes.
* Simplified output outputs hex with all leading zeroes
*

        lea.l key,a1
        move.w sb.inipr,a2
        jmp (a2)

key
        dc.w 0,0

        dc.w 2
        dc.w mulu-*
        dc.b 9,'MULU3264$'
        dc.w 0

mulu
        move.w sb.gtlin,a2
        jsr (a2)
        bne.s exit
        subq.w #2,d3
        bne.s err_bp

        movem.l (a6,a1.l),d1/d2
        bsr.s mulu3264

        moveq #10,d1
        move.w qa.resri,a2
        jsr (a2)

        sub.l #10,sb_arthp(a6)
        move.l sb_arthp(a6),a1
        move.w #16,(a6,a1.l)

        move.l d5,d0
        bsr.s cv
        move.l d4,d0
        bsr.s cv

        move.l sb_arthp(a6),a1
        moveq #ar.strng,d4
        moveq #0,d0
        rts

*
err_bp
        moveq #err.ipar,d0
        rts

err_ov
        moveq #err.ovfl,d0

exit
        rts

*
cv
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert longword in d0 to hex on RI stack
*
        moveq #7,d1

lp
        rol.l #4,d0
        move.b #$0f,d2
        and.b d0,d2
        cmpi.b #$9,d2
        bhi.s hex
        add.b #'0',d2
        bra.s nxt
hex
        add.b #55,d2            hexify
nxt
        move.b d2,2(a6,a1.l)
        addq.l #1,a1
        dbra d1,lp
        rts

*
        end
